Subject: Re: perl/Git.pm: Writing a test suite

From: Petr Baudis <[email-masked]>
Date: Fri, 30 May 2008 12:03:06 +0200

Hi,

On Fri, May 30, 2008 at 09:43:48AM +0200, Lea Wiemann wrote:
> Git.pm doesn't currently have a test suite, and I think it should get one.
>
> Since Git.pm makes calls to the git binary, it would seem sensible to me to 
> create mock output for the external calls, like Grit (a Ruby API) does it, 
> here: http://github.com/mojombo/grit/tree/master/test/fixtures  (Having a 
> complete test repository to test against like Ruby/Git (another API) at 
> http://repo.or.cz/w/rubygit.git?a=tree;f=tests/files;hb=HEAD is probably 
> too brittle and makes it hard to test edge cases.)

  I think this is bad idea; you should test not just Git.pm
functionality, but equally importantly also its integration with
(current version of) Git. If Git's output/behaviour changes in some
subtle way, you want to see if it breaks Git.pm.

> I haven't done testing in perl before, so if someone wants to exchange 
> ideas and/or help me get this set up, please post here or message me on IRC 
> (lea_w/lea_1 on #git at Freenode).

  There are two possible ways, either using the Git test suite
infrastructure, or the Perl test suite infrastructure. I'm ambivalent
about which one to choose, both have their advantages; I wonder what
others' opinion is. I would personally go with the Perl test suite in
this case but can't support it with much more than just a gut feeling.

-- 
				Petr "Pasky" Baudis
Whatever you can do, or dream you can, begin it.
Boldness has genius, power, and magic in it.	-- J. W. von Goethe